package uk.ac.umist.co.brailletrans.tests;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.text.*;
import java.io.BufferedInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileInputStream;

public class CompareCompiledLanguageFiles
{
  public static void main(String[] args) throws Exception
  {
    BufferedInputStream oldFile = null;
		  // Used for file input
    BufferedInputStream newFile = null;
      // For file output
    final String oldFilename = "Tb5.dat";
    final String newFilename = "tester.dat";
    Result older = new Result();
    Result newer = new Result();

    // Try to open read files
    oldFile = new BufferedInputStream(new FileInputStream(oldFilename));
    newFile = new BufferedInputStream(new FileInputStream(newFilename));

    //Do versions
    older.printTitle("Old language");
    older.printTitle("Versions:");
    newer.printTitle("New language");
    newer.printTitle("Versions:");
    for (int i = 0; i < 4; i++)
    {
      older.print(oldFile.read());
      newer.print(newFile.read());
    }
    older.newLine();
    newer.newLine();

    //Do character rules
    older.printTitle("Character rules:");
    newer.printTitle("Character rules:");
    for (int i = 0; i < 256; i++)
    {
      older.print(i + " = " + oldFile.read());
      older.print(oldFile.read());
      older.println(oldFile.read());
      newer.print(i + " = " + newFile.read());
      newer.print(newFile.read());
      newer.println(newFile.read());
    }
    older.printTitle("WILDCARD INFO:");
    newer.printTitle("WILDCARD INFO:");
    older.println("number of wildcards = " + oldFile.read());
    newer.println("number of wildcards = " + newFile.read());
    for (int i = 0; i < 7; i++)
    {
      older.print("char=" + oldFile.read());
      older.print("number=" + oldFile.read());
      older.println("flags=" + oldFile.read());
    }
    for (int i = 0; i < 4; i++)
    {
      newer.print("char=" + newFile.read());
      newer.print("number=" + newFile.read());
      newer.println("flags=" + newFile.read());
    }

    older.printTitle("STATE INFO");
    newer.printTitle("STATE INFO");
    older.println("number of states = " + oldFile.read());
    newer.println("number of states = " + newFile.read());
    older.println("number of input classes = " + oldFile.read());
    newer.println("number of input classes = " + newFile.read());

    older.printTitle("Next ten...");
    newer.printTitle("Next ten...");
    for (int i = 0; i < 10; i++)
    {
      older.print(oldFile.read());
      newer.print(newFile.read());
    }



    oldFile.close();
    newFile.close();

    JFrame disp = new JFrame("Language comparison results");
    Container c = disp.getContentPane();
    c.setLayout(new GridLayout(1, 2));
    String resultOld = older.getResult();
    String resultNew = newer.getResult();
    JTextArea displayNew = new JTextArea(resultNew, 10, 10);
    JScrollPane scrollNew = new JScrollPane(displayNew);
    JTextArea displayOld = new JTextArea(resultOld, 10, 10);
    JScrollPane scrollOld = new JScrollPane(displayOld);
    c.add(scrollOld);
    c.add(scrollNew);
    disp.setSize(500, 300);
    disp.setVisible(true);


//    JOptionPane.showMessageDialog(null, new JScrollPane(display), "Language comparisons",
//      JOptionPane.NO_OPTION);



  }


}

class Result
{
  int index;
  String output;

  Result()
  {
    index = 0;
    output = "";
  }

  void print(int newChar)
  {
    output = output + newChar + " ";
    index++;
  }

  void print(String newString)
  {
    output = output + newString + " ";
    index += newString.length();
  }

  void println(int newChar)
  {
    output = output + newChar + "\n";
    index++;
  }

  void println(String newString)
  {
    output = output + newString + "\n";
    index += newString.length();
  }

  String getResult()
  {
    return "\n" + output + "\n";
  }

  void newLine()
  {
    output += "\n";
  }

  void printTitle(String title)
  {
    output += "\n" + title + "\n";
  }
}



