package uk.ac.umist.co.brailletrans.tests;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import uk.ac.umist.co.brailletrans.*;
import uk.ac.umist.co.brailletrans.tests.Stopwatch;


public class TranslateCDummy extends Translator
{

  private static final int DLL_ERROR = 4;

  // native function prototypes
  public native int InitBrl(String languageName);
  public native int Translate(byte[] StrIn, byte[] StrOut);
  public native int SetState(byte newState);


  // dll loader - dll should contain all of C functions detailed above
  static
  {
    try
    {
      System.loadLibrary("CBrailleTransTest");
    }
    catch(UnsatisfiedLinkError e)
    {
      System.err.println("Could not load CBrailleTransTest dll:" + e);
      System.exit(DISK_ERROR);
    }
  } // end of static block



}
